Package org.spongepowered.asm.util

## Enum Bytecode.Visibility

- java.lang.Object
- - java.lang.Enum<Bytecode.Visibility>
  - - org.spongepowered.asm.util.Bytecode.Visibility

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<Bytecode.Visibility>`
  Enclosing class:
    Bytecode

      public static enum Bytecode.Visibility
      extends java.lang.Enum<Bytecode.Visibility>

  Ordinal member visibility level. This is used to represent visibility of a member in a formal way from lowest to highest. The `Bytecode.getVisibility(org.objectweb.asm.tree.MethodNode)` methods can be used to convert access flags to this enum. The value returned from `Enum.ordinal` can then be used to determine whether a visibility level is higher or lower than any other given visibility level.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `PACKAGE` | Members not decorated with any access flags
    `PRIVATE` | Members decorated with `Opcodes.ACC_PRIVATE`
    `PROTECTED` | Members decorated with `Opcodes.ACC_PROTECTED`
    `PUBLIC` | Members decorated with `Opcodes.ACC_PUBLIC`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `isAtLeast​(Bytecode.Visibility other)` | Get whether this visibility level represents a level which is the same or greater than the supplied level
    `boolean` | `isLessThan​(Bytecode.Visibility other)` | Get whether this visibility level represents a level which less than the supplied level
    `static Bytecode.Visibility` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static Bytecode.Visibility[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### PRIVATE

          public static final Bytecode.Visibility PRIVATE

      Members decorated with `Opcodes.ACC_PRIVATE`

    - #### PROTECTED

          public static final Bytecode.Visibility PROTECTED

      Members decorated with `Opcodes.ACC_PROTECTED`

    - #### PACKAGE

          public static final Bytecode.Visibility PACKAGE

      Members not decorated with any access flags

    - #### PUBLIC

          public static final Bytecode.Visibility PUBLIC

      Members decorated with `Opcodes.ACC_PUBLIC`

  - ### Method Detail

    - #### values

          public static Bytecode.Visibility[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Bytecode.Visibility c : Bytecode.Visibility.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Bytecode.Visibility valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### isAtLeast

          public boolean isAtLeast​(Bytecode.Visibility other)

      Get whether this visibility level represents a level which is the same or greater than the supplied level
      Parameters:
        `other` - level to compare to
      Returns:
        true if greater or equal

    - #### isLessThan

          public boolean isLessThan​(Bytecode.Visibility other)

      Get whether this visibility level represents a level which less than the supplied level
      Parameters:
        `other` - level to compare to
      Returns:
        true if greater or equal